/*  AX25 Level 2  --  KE3Z  08/19/87  */

struct axcb {
	struct axcb *next;		/* Forward link			*/
	struct axcb *prev;		/* Backward link		*/
	struct interface *iface;	/* Hardware interface definition*/
/*	struct interface *ifspec;	/* Interface specified on open	*/
	char port;			/* Port to use */
	struct ax25_addr myaddr;	/* Local AX25 address		*/
	struct ax25_addr path[9];	/* Level 2 addressing info	*/
	int alen;			/* Length of path		*/
/*	struct ax25_addr pathspec[9];	/* Path specified on open	*/
/*	int speclen;			/* Length of specified path	*/
	struct datastr *iqueue;		/* Transmission queue		*/
	int icnt;			/* Count of bytes on transmit queue*/
	struct datastr *rcvq;		/* Receive queue		*/
	int rcvcnt;			/* Count of bytes on receive queue*/
	int flags;			/* Bit flags			*/
#define BUSY		2		/* Receiver is busy		*/
#define INVNS		4		/* Invalid send-sequence number rcvd*/
#define FULL		8		/* Link is full duplex		*/
	int window;			/* Receive window		*/
	int rctl;			/* Received control field	*/
	int rcmd;			/* Receive command flag		*/
	int n2cnt;			/* Retry counter		*/
	char ns;			/* Current send-sequence number	*/
	char nr;			/* Current receive-sequence number*/
	char vs;			/* Send-sequence variable	*/
	char state;			/* Current protocol state	*/
	char info[4];			/* Last FRMR sent (for retrans)	*/
	struct tmrblk *t1;		/* Waiting-acknowledgement timer*/
	struct tmrblk *t2;		/* Response-delay timer		*/
	struct tmrblk *t3;		/* Inactive-link timer		*/
	char version;			/* Protocol version in use	*/
#define V1			0
#define V2			1
	struct ax25_parms *parms;	/* Link parameters		*/
	void (*r_upcall)();		/* Receiver upcall handler	*/
	void (*t_upcall)();		/* Transmit upcall handler	*/
	int (*s_upcall)();		/* State-change upcall handler	*/
/*	char *user;			/* Server's data		*/
	unsigned char rpid;		/* Received PID			*/
				/* X.25 Link level data for R states	*/
	struct tmrblk *t20;		/* Restart Timer (T20)		*/
	unsigned char am_dce;		/* Which am I? (DTE/DCE)	*/
	struct VCS *llcn;		/* My list of vc's		*/
	unsigned char R;		/* Current R state		*/
	unsigned char coll;		/* Restart Collision counter	*/
	unsigned char maxvc;		/* max number of active vc's	*/
	char link_num;			/* If non-zero, index into L3CALLS */
};

#define NULLAXCB ((struct axcb *) 0)

struct change {
	char newstate;	/* New state, or 0 if no change		*/
	char ctl;	/* Control field to send, 255 if none	*/
	char acts;	/* Bit flags				*/
#define CMD	1	/* Response frame is a command		*/
#define RSTT1	2	/* Reset the T1 timer			*/
#define SETT1	4	/* Start the T1 timer			*/
#define RESPOND	8	/* Response required			*/
};

extern struct axcb *links;		/* Head of link list	*/

struct ax25_parms {
	char version;			/* Default protocol version	*/
	int frack;			/* Initial T1 timer value, sec.	*/
	int resptime;			/* Initial T2 timer value, sec.	*/
	int check;			/* Initial T3 timer value, sec.	*/
	int retry;			/* Initial N2 count		*/
	char maxframe;			/* Maximum # of outstanding frames*/
	int framesize;			/* Maximum I-field length	*/
};

/* Codes for the ax25_open call */
#define	AX25_PASSIVE 0
#define	AX25_ACTIVE 1

extern struct change i_cmd[], i_cmdp[], rr_cmd[], rr_cmdp[], rej_cmd[],
	 rej_cmdp[], rnr_cmd[], rnr_cmdp[], sabm_cmd[], disc_cmd[], rr_resp[],
	 rr_respf[], rej_resp[], rej_respf[], rnr_resp[], rnr_respf[],
	 ua_resp[], dm_resp[], frmr_resp[], go_busy[], clr_busy[], t1_exp[],
	 t1_expv1[], t3_exp[], inv_ns[], inv_nsv1[], n2_exceeded[],
	 val_ns[], val_nsv1[];

extern char *axstates[];

struct axcb *open_ax25(), *new_link();
#define free_link(p) free_stuff(&p)
void free_stuff();
/* (a,b,c) = (Src, Dest, Len) */
#define bcopy(a,b,c) bmove(a,b,c)
#define memcpy(b,a,c) bmove(a,b,c)
