;/*
; * Copyright 1988 by the Radio Amateur Telecommunications Society
; * and Thomas A. Moulton, W2VY
; *
; * This software may only be modified, copied, distributed or
; * executed for non-profit purposes by individuals operating
; * systems in the Amateur Radio Service.  Credit to the
; * author(s) and to the Radio Amateur Telecommunications Society
; * must be made in modules where RATS provided software is used,
; * and in any announcements and documentation.  
; *
; * As a non-profit, research and development organization,  the
; * Radio Amateur Telecommunications Society distributes software
; * in both executable and source forms.  This policy is in place
; * to encourage the development and distribution of OSI-based,
; * networking tools.  In order to protect the interests of the
; * Society and the authors, we have placed some conditions
; * of use on the software.  Other groups are encouraged
; * to place the same or similar guidelines on
; * software they produce.
; *
; * The Radio Amateur Telecommunications Society reserves the right
; * to specify and alter the terms under which software provided by
; * the Society may be used.  This policy is consistent with the 
; * objective of uniform and consistent "Open Systems Interconnections."
; * 
; * All acceptable Amateur Radio related uses of this software
; * will be outlined in the "ROSE Implementer's Guide".  Individuals
; * or organizations wishing to add to, or modify the provisions of
; * the guide to accommodate local or evolutionary requirements
; * should document the proposed change(s) and forward them to the
; * Society.  If accepted, written notification will be provided by
; * the Society to the submitting organization or individual(s).
; * The Society will then issue a "ROSE Implementer's Guide Change
; * Notice".  Periodically, the Society will re-issue the "ROSE 
; * Implementer's Guide" and incorporate the text of the change 
; * notices.  This procedure has been put in to place to ensure
; * compatibility between systems and to ensure their "Openness"
; * and interoperability.
; *
; * No part of this software may be used in other packages 
; * without prior authorization from the author or the Society.  
; * Software incorporating this module, all or in part, must be 
; * provided to the Society prior to distribution or use by
; * anyone not directly involved in testing of the revised  
; * environment.  Current releases of the combined software must
; * be provided to the Society in both source and executable
; * forms.  Adequate documention to produce an executable module 
; * from the provided source must also be included.
; *
; * Non-Amateur Radio non-profit uses may be authorized on a case
; * by case basis.  Inquiries for such use may be made in writing
; * to the Society. Non-commercial uses consistent with the
; * general principles of Open Systems Interconnection Reference
; * Model will be generally considered with favor.
; *
; * Commercial licensing of the software is also available based
; * on normal commercial terms.  Licensing inquiries should be
; * directed to the Society.  Commercial licensing of the standard
; * software will be done in situations which materially benefit
; * the Amateur Radio Packet Network.  Additional licensing is
; * reserved by the individual authors.
; * 
; * The Radio Amateur Telecommunications Society provides this software
; * on an "as is" basis.  The Society assumes no liability for
; * loss incurred through the use of this software.  Amateur Radio
; * use of this software implies non-commercial and voluntary 
; * development, deployment and use of this software in a "Amateur",
; * non-commercial service.  Commercial users are encouraged to
; * inspect their copies of the source code.  Source code modification
; * licenses are available if a combined Object and Source Code
; * license was not originally established.
; * 
; * The Society may be contacted by writing or calling at:
; * 
; * The Radio Amateur Telecommunications Society 
; * 206 North Vivyen Street.
; * Bergenfield, New Jersey 07621
; *
; * Telephone: 201-387-8896
; *
; */
*Title Level 2 Interface routines to the SIO

;
*INCLUDE ENVIR.DEF
*INCLIDE RCONFIG.LIB
*INCLUDE STRUCT.LIB

;	Option for OS_QUE to place task on the top instead of the end
FORCE	EQU	80h	;Low bits are # of arg in DE, BC and HL=A(rtn)

;	Structure of a Packet (FIX if BUFFER.H is changed)
;
NEXTS	EQU	0	;Pointer to next segment
NEXT	EQU	2	;Pointer to next Packet
RDATA	EQU	4	;Pointer to next char to be read from buffer
WDATA	EQU	6	;Pointer to next char written to buffer
BUFMAX	EQU	8	;Pointer to last ch in segment
BUFSIZE EQU	10	;Size of this structure

	PSECT	bss
	GLOBAL	_COLD
	GLOBAL	QTRASH, QUEFUL, QUEUE, QSLOTS, TWEEK, _L1BSSL, _L1BSS
_L1BSS	EQU	$
QTRASH: DEFS	1
QUEFUL:	DEFS	1
QUEUE:	DEFS	4	;STRUCT QUEUE
QMAX	EQU	0	;MAX	DS	1 WITH LD HL,(QUEUE) THIS IS L
QUSED	EQU	1	;USED	DS	1			     H
QBOT	EQU	2	;BOT	DS	1 WITH LD HL,(QUEUE+BOT)     L
QTOP	EQU	3	;TOP	DS	1			     H
QSLOTS:	DEFS	NSLOT*4
TWEEK:	defs	1
_L1BSSL	EQU	$-QTRASH

IXSAVE:	DEFS	2
IYSAVE:	DEFS	2
SPSAVE:	DEFS	2
TRTN:	DEFS	2
;	FREEQ:	DEFS	2
;	_INTS_OFF: DEFS 1

	PSECT	text
	GLOBAL	csv, rcsv, cret, indir
	GLOBAL	_free_packet, _L1_RECV, GETSIO, XSKED
	GLOBAL	_bgetch, _bappch, _new_buffer
EXIT:
	POP	IX
	EI
	JP	cret

	GLOBAL	_SIO_SND
_SIO_SND:
	CALL	rcsv	;SIO_SND(port,pkt) HL=port DE=pkt
	PUSH	IX	;SAVE THE C REGS
	LD	A,E	;IS THE PACKET NULL?
	OR	D
	JP	Z,EXIT

	CALL	GETSIO	;CONVERT HL FROM PORT # TO SDS STRUCT, TRASHES BC
	JP	NZ,1f
freeit:	PUSH	DE
	CALL	_free_packet	;BAD CHAN #, FREE THE PACKET
	POP	DE
	LD	HL,0
	JP	EXIT

1:	PUSH	HL
	POP	IY	;GET POINTER TO MY STRUCT
	DI
;	call	nextck
	LD	L,(IY+TXQ)
	LD	H,(IY+(TXQ+1))
	LD	A,L		;IS THE TXQ EMPTY?
	OR	H
	JP	NZ,ATEND	;NOPE, ADD TO END
	LD	(IY+TXQ),E	;Put new item on top of queue
	LD	(IY+(TXQ+1)),D
	JP	SENDING

ATEND:	PUSH	HL
	POP	IX		;NEED TO SAVE IY FOR INTR RTNS
	LD	L,(IX+NEXT)	;TRY NEXT ENTRY
	LD	H,(IX+(NEXT+1))
	LD	A,L
	OR	H		;IS THE NEXT NULL?
	JP	NZ,ATEND	;NOPE, KEEP SCANNING
	LD	(IX+NEXT),E
	LD	(IX+(NEXT+1)),D	;STUFF IT INTO THE LAST PKT
SENDING:
	PUSH	DE
	POP	IX
	LD	(IX+NEXT),0	;INSURE IT POINTS TO NULL
	LD	(IX+(NEXT+1)),0

	LD	A,(IY+TSTA)	;ARE WE SENDING?
	OR	A
	CALL	Z,XSKED		;WE ARE IDLE, START US UP AGAIN
	JP	EXIT
;

	GLOBAL	SIOTXCH
SIOTXCH:
	LD	C,(IY+TXSEG)	;GET POINTER TO CURRENT SEG
	LD	B,(IY+(TXSEG+1))
	LD	A,B
	OR	C		;IS IT NULL?
	JP	NZ,TXCHAR	;NOPE, CHECK FOR DATA
	BIT	AFT,(IY+FLAG)	;Using AFT?
	JP	Z,1f
	LD	A,(IY+TXAFT)	;What is our state?
	SUB	3
	JP	M,1f		;Less than 3
	INC	A
	JP	AFTCRC		;Sending CRC and ending flag

1:	LD	C,(IY+TXQ)	;ANYTHING WAITING?
	LD	B,(IY+(TXQ+1))
	LD	A,B
	OR	C
	LD	A,1		;ASSUME NOTHING WAITING
	RET	Z		;Everything NULL, nothing to do
	LD	(IY+TXSEG),C	;STUFF IT AND GET THIS SHOW ON THE ROAD
	LD	(IY+(TXSEG+1)),B
	PUSH	BC
	POP	IX		;TXSEG=TXQ
	LD	A,(IX+NEXT)
	LD	(IY+TXQ),A	;TXQ=TXSEG->NEXT
	LD	A,(IX+(NEXT+1))
	LD	(IY+(TXQ+1)),A
	LD	A,0
	LD	(IX+NEXT),A
	LD	(IX+(NEXT+1)),A	;TXSEG->NEXT=NULL

TXCHAR:	BIT	AFT,(IY+FLAG)	;Using AFT?
	JP	Z,1f
	LD	A,(IY+TXAFT)	;What is my state?
	OR	A		;Idle? (State 0)
	JP	Z,TXFLAG	;Yes, Send Flag instead of data
	DEC	A		;Get next byte? (State 1)
	JP	NZ,AFTBYT	;No, do AFT Handling
1:	PUSH	IY		;Get the next byte from buffer
	POP	HL
	LD	BC,TXSEG	;IY+TXSEG IS THE POINTER TO THE CURRENT
	ADD	HL,BC		;PACKET BEGIN SENT
	PUSH	HL
	CALL	_bgetch		;bgetch(&TXSEG)
	POP	BC		;RETURNS CHAR OR -1 IF EOF
	LD	A,H
	OR	A		;IS IT A CHAR?
	JP	NZ,TXEOF
	LD	B,L
	DEC	A		;It's a Char (A now = 0FFh)
	BIT	AFT,(IY+FLAG)	;AFT?
	RET	Z		;Nope, done
	LD	L,(IY+TXCRC)
	LD	H,(IY+(TXCRC+1))
	CALL	CRCA		;Compute AFT CRC, Char in B, CRC in HL
	LD	(IY+TXCRC),L
	LD	(IY+(TXCRC+1)),H
	LD	A,7Dh
	CP	B		;Is it the AFT Escape Char?
	JP	Z,1f
	INC	A
	CP	B		;Is it the AFT Flag?
	LD	A,0FFh		;Assume it's just a data byte
	RET	NZ
1:	XOR	20h		;Do Transparency
	LD	(IY+TXAFT),2	;Need to send TBUF next
	LD	(IY+TBUF),A	;Save it
	LD	B,7Dh		;Send Escape
	LD	A,0FFh		;It's data
	RET

TXFLAG:	LD	B,7Eh		;AFT Start Flag
	LD	(IY+TXAFT),1	;Now in data transfer
	LD	A,0FFh		;Treat it as data
	LD	(IY+TXCRC),A
	LD	(IY+(TXCRC+1)),A ;Reset TX CRC
	RET

TXEOF:	BIT	AFT,(IY+FLAG)	;AFT?
	JP	NZ,AFTCR	;Yes, push out the CRC
TXMOR:	LD	A,(IY+TXQ)
	OR	(IY+(TXQ+1))	;MORE WAITING?
	LD	A,0
	RET	NZ		;YES
	LD	A,1
	RET			;NOPE, EOT

AFTBYT:	DEC	A		;In transparency sequence? (State 2)
	JP	NZ,AFTCRC	;Sending CRC
	LD	B,TBUF
	LD	A,0FFh		;Send as Data
	LD	(IY+TXAFT),1	;Back in normal Data Transfer
	RET

AFTCR:	LD	(IY+TXAFT),3	;Need to send high byte of CRC next
	LD	B,(IY+TXCRC)	;Get low byte to send now
	JP	1f		;Yes

AFTCRC:	LD	B,(IY+(TXCRC+1)) ;High byte needs to be sent (State 3)
	INC	(IY+TXAFT)	;Advance for next time
	DEC	A		;Right?
	JP	Z,1f		;Yes
	DEC	A		;Ending Flag? (State 4)
	JP	Z,TXFLAG	;Allow Ending flag to open next frame
1:	LD	A,B
	XOR	0FFh		;1's comp
	LD	B,A
	LD	A,0FFh		;Data
	RET

	GLOBAL	TXODONE
TXODONE:
	LD	E,(IY+TXQ)	;IS THERE STILL MORE TO TX?
	LD	D,(IY+(TXQ+1))
	LD	A,E
	OR	D
	JP	NZ,XSKED	;Start sending again!
	LD	(IY+TXAFT),0	;Since we aren't sending anymore, force start
	RET			;Flag for next AFT frame

	GLOBAL	SIORXCH
SIORXCH:
	LD	E,(IY+RXQ)	;GET THE CURRENT PKT
	LD	D,(IY+(RXQ+1))
	LD	C,A		;SAVE A
	LD	A,E
	OR	D
	JP	Z,RXABORT		;NO PACKET TO FILL, ABORT
	LD	A,C	
	PUSH	DE
	POP	IX		;Put in IX too

	CP	0FFh		;RX DATA?
	JP	Z,RXCHAR	;Yes, STUFF IT!
	CP	0		;START OF FRAME?
	JP	NZ,RXEND	;NOPE, MAYBE END
	LD	A,(IX+RDATA)	;GET THE INITIAL WRITE POINTER
	LD	(IX+WDATA),A	;RESET IT TO BEGINING
	LD	A,(IX+(RDATA+1))
	LD	(IX+(WDATA+1)),A ;PKT->WDATA=PKT->RDATA
RXCHAR:
	BIT	AFT,(IY+FLAG)	;Using AFT?
	JP	NZ,AFTRX
RXCH:	LD	H,0
	LD	L,B		;GET THE RX CHAR
	PUSH	HL
	PUSH	DE		;PACKET TO STUFF IT INTO
	CALL	_bappch		;bappch(RXQ,CH)
	POP	BC		;RETURNS -1 (IN HL) IF NO SPACE
	POP	BC
	LD	A,L
	OR	H
	RET	Z		;The char fix, HDLC, ASYNC and AFT are happy
	LD	A,(IY+FLAG)	;Buffer full error - get Flags
	BIT	AFT,A		;to see if we care
	JP	NZ,RXABORT	;This is an error for AFT
	BIT	ASYNC,A		;Simple Async Stream doesn't care
	JP	NZ,RXASY
	JP	RXABORT		;Must be HDLC, is an error

AFTRX:	LD	A,(IY+RXAFT)	;Get State
	OR	A		;Looking for a Flag? (State 0)
	JP	Z,AFTFLG	;Yes
	DEC	A		;Dxfer? (State 1)
	JP	NZ,AFTTR	;Must be in Escape Sequence (State 2)
	LD	A,7Dh		;Escape?
	CP	B
	JP	NZ,1f		;Nope
	LD	(IY+RXAFT),2	;Next char needs to be translated
	LD	A,0
	RET
1:	INC	A		;Flag?
	CP	B
	JP	NZ,CRAFT	;Compute CRC and return Char
	LD	A,(IY+RXCRCL)	;Rx anything since last flag?
	OR	A
	RET	Z		;Nope, was Flag-Flag-...
	LD	(IY+RXAFT),1	;Got Ending Flag, treat as opening flag too
	JP	RXAEOF

AFTTR:	DEC	A
	JP	NZ,RXABORT	;Illegal State (State greater than 2)
	LD	A,7Eh		;Insure it's not a flag (Abort sequence)
	CP	B
	JP	Z,RXABORT	;Esc-Flag, Abort sequence
	LD	A,20h
	XOR	B
	LD	B,A		;Translated Char
	LD	(IY+RXAFT),1	;Back to normal
CRAFT:	LD	L,(IY+RXCRC)
	LD	H,(IY+(RXCRC+1))
	CALL	CRCA		;Compute AFT CRC, Char in B, CRC in HL
	LD	(IY+RXCRC),L
	LD	(IY+(RXCRC+1)),H
	LD	A,(IY+RXCRCL)	;Is the crc buffer full?
	CP	2
	JP	M,CRFIL		 ;Nope, Fill it up!
	CP	3		 ;Have we had any data yet?
	JP	Z,1f
	INC	(IY+RXCRCL)	 ;Remember that there was data in the frame
1:	LD	C,(IY+CRBUF)	 ;Get Top
	LD	A,(IY+(CRBUF+1)) ;Move Second to
	LD	(IY+CRBUF),A	 ;Top
	LD	(IY+(CRBUF+1)),B ;Put New in Second
	LD	B,C		 ;Stuff Old top into our buffer
	JP	RXCH

CRFIL:	INC	(IY+RXCRCL)	;Adding a byte to the buffer
	OR	A		;Do we have any bytes?
	JP	Z,1f		;Nope, make it the top item
	DEC	A		;Do we have 1 byte?
	JP	NZ,RXABORT	;Nope, we are Messed up!
	LD	(IY+(CRBUF+1)),B ;Make it the Second Item
	RET

1:	LD	(IY+CRBUF),B	;Top Item
	RET

AFTFLG:	LD	A,7Eh		;AFT Flag Char
	CP	B
	LD	A,0
  	RET	NZ		;Not Flag, ignore
	DEC	A
	LD	(IY+RXCRC),A	;Opening Flag, Reset CRC
	LD	(IY+(RXCRC+1)),A
	INC	A		;Return No Error (0)
	LD	(IY+RXAFT),1	;In Data Transfer
	RET

RXASY:	OR	A		;EOF?
	JP	NZ,RXAEOF	;Yes, Buffer is full, Return it, CR will follow
	LD	A,C		;Get char back
	AND	7FH		;STRIP PARITY
	CP	0DH		;IS IT A CR?
	LD	A,0		;Assume No
	RET	NZ		;NO, MORE TO FOLLOW!
RXAEOF:	LD	(IY+RSTA),0	;Async back in idle state
	LD	A,1		;End of Frame (Async).
RXEND:	CP	1		;END OF FRAME?
	JP	NZ,RXABRT	;MAYBE A FRAME ABORT?
	BIT	AFT,(IY+FLAG)	;Using AFT?
	JP	Z,1f
	LD	A,0B8h		;Correct CRC?
	CP	(IY+RXCRC)
	JP	NZ,RXABORT	;Bad, Abort
	LD	A,0F0h		;Correct CRC?
	CP	(IY+(RXCRC+1))
	JP	NZ,RXABORT	;Abort
	LD	A,3		;Did we get atleast 3 Bytes?
	CP	(IY+RXCRCL)
	JP	NZ,RXABORT
	XOR	A
	LD	(IY+RXCRCL),A	;Reset some stuff for the next frame
	DEC	A
	LD	(IY+RXCRC),A
	LD	(IY+(RXCRC+1)),A
1:	LD	C,(IX+NEXT)	;RXQ=RXQ->NEXT
	LD	B,(IX+(NEXT+1))
	LD	(IY+RXQ),C
	LD	(IY+(RXQ+1)),B
	LD	(IX+NEXT),0	;PKT->NEXT=NULL
	LD	(IX+(NEXT+1)),0
	PUSH	IX		;Restore DE
	POP	DE
QUERX:	LD	B,0
	LD	C,(IY+CHAN)	;GET THE CHANNEL NUMBER
	LD	HL,_L1_RECV
	LD	A,2
	CALL	OS_QUE
	LD	A,0
	RET

RXABORT:
	XOR	A
	LD	(IY+RXAFT),A	;AFT Flag Hunt
	LD	(IY+RXCRCL),A	;No data yet
	LD	A,0FFh		;FAILED, ENTER FLAG HUNT
	LD	(IY+RXCRC),A
	LD	(IY+(RXCRC+1)),A ;Reset AFT RX CRC
	RET

RXABRT:	CP	2		;FRAME ABORTED?
	LD	A,0FFh		;NOTE THE ERROR
	RET	NZ		;INVALID, IGNORE CALL
	LD	A,(IX+RDATA)	;RESET THE CURRENT WRITE POINTER
	LD	(IX+WDATA),A
	LD	A,(IX+(RDATA+1))
	LD	(IX+(WDATA+1)),A
	LD	A,0
	RET

CRCA:	;Compute AFT CRC, Char in B, CRC in HL, DON'T Use DE
	PUSH	BC	;Save Char
	LD	C,B	;Need B for the loop
	LD	B,8	;8 bits per octet
CRCB:	LD	A,C	;Get current bit
	XOR	L
	SRL	H	;fcs = fcs>>1
	RR	L
	RR	A
	JP	NC,1f
	LD	A,84h
	XOR	H
	LD	H,A	;fcs = fcs ^ 0x8408
	LD	A,08h
	XOR	L
	LD	L,A
1:	RR	C	;Advance to next bit
	DJNZ	CRCB
	POP	BC	;Restore Char
	RET

	global	_RX_GIVE
_RX_GIVE:			;RX_GIVE(CHAN,PKT,depth)
	CALL	rcsv		;	  HL  DE
	PUSH	IX	;SAVE THE C REGS

	LD	A,E	;IS THE PACKET NULL?
	OR	D
	JP	Z,RXGNIL	;DON'T HAVE A PACKET
	CALL	GETSIO		;FIND THE SDS STRUCT
	JP	Z,freeit	;BAD CHAN NUMBER FREE THE PACKET
	PUSH	HL
	POP	IY		;GET THE SDS POINTER
	DI
	LD	B,(IX+10)	;MAX # OF PACKETS ON A RECV QUEUE (par 3)
	LD	L,(IY+RXQ)	;GET THE RX POOL POINTER
	LD	H,(IY+(RXQ+1))
	LD	A,L
	OR	H
	JP	NZ,APPEND	;APPEND IT TO THE QUEUE
	LD	(IY+RXQ),E	;STUFF IT, HOW MUCH DID WE MISS?
	LD	(IY+(RXQ+1)),D
	LD	HL,1		;We Want more packets
	JP	1f
RXGNIL:	LD	HL,0		;RETURN FALSE
1:	JP	EXIT		;START RX'ING AGAIN!

APPEND:
	PUSH	HL
	POP	IX		;GET THE TOP PACKET
	LD	L,(IX+NEXT)	;HL=IX->NEXT
	LD	H,(IX+(NEXT+1))
	LD	A,L
	OR	H
	JP	Z,APEND		;FOUND THE END
	DJNZ	APPEND		;LOOP UPTO 10 TIMES
	EI			;I GIVE UP, TOO MUCH HERE FOR HIM
	JP	freeit		;freeit returns 0 (FALSE)

APEND:	LD	(IX+NEXT),E	;IX->NEXT=DE
	LD	(IX+(NEXT+1)),D
	LD	HL,1		;We Want more packets return TRUE
	JP	EXIT

	GLOBAL	_OS_QUE
_OS_QUE:	;OS_QUE(rnt,P1)	CONVERT TO ASM CONVENTIONS
	DI
	CALL	rcsv
	PUSH	IX	;SAVE THE C REG
	LD	A,1
	CALL	OS_QUE
	POP	IX	;RESTORE C REG
	EI		; Ints were enabled, re-enable
	JP	cret


	GLOBAL	OS_QUE, OS_TASK
OS_QUE:			;SCHEDULE SOMETHING TO HAPPEN	ints OFF or die
			;HL IS THE A(ROUTINE)
			;A = 8x (HEX) TO FORCE THIS ITEM TO BE ON TOP
			;A   xN	WHERE N IS THE NUMBER OF ARGS
			;DE IS ARG #1 IF A=1 OR A=2
			;BC IS ARG #2 IF A=2
	PUSH	BC	;SAVE ARG #2
	PUSH	DE	;SAVE ARG #1
	PUSH	HL	;SAVE ADDRESS

	LD	HL,(QUEUE)	;H=# USED. L=MAX
	CP	3
	JP	P,BADARG	;TOO MANY ARGS REQUESTED!
	AND	07h		;CLEAR HIGH BITS
	PUSH	AF	;SAVE LEN
	LD	B,1		;SLOTS NEEDED FOR #ARG =0
	CP	0		;IS THAT WHAT WAS ASKED FOR?
	JP	Z,1f		;YUP
	LD	B,2		;FOR #ARGS = 1 OR 2 WE NEED 2 SLOTS
1:	LD	A,L
	SUB	H		;A=L-H (MAX-USED)
	JP	Z,QUEFULL	;OOPS, L=H
	JP	M,QUEFULL	;OOPS, L<H
	CP	B		;IF # SLOTS LEFT >= # SLOTS NEEDED WE ARE OK
	JP	M,QUEFULL	;HAVE ROOM
	POP	AF
;	OR	A		;IS FORCE (SIGN) BIT SET?
;	JP	M,QUEFRC	;FORCE THIS ON THE TOP OF THE QUEUE
	LD	C,A		;FORM THE 1ST SLOT
	LD	B,0		;NUMBER OF ARGS
	POP	DE		;A(ROUTINE)
	LD	A,(QUEUE+QBOT)	;ADD TO THE BOTTOM
	CALL	STUFF_IT	;STUFF BC/DE IN SLOT # A
	INC	A		;BUMP IT UP, STUFF_IT WILL WRAP IT WHEN NEEDED
	LD	(QUEUE+QBOT),A	;SAVE POINTER
	LD	A,C		;# ARG
	POP	BC
	POP	DE		;POP ARG 1 AND 2 IF PRESENT
	CP	0		;NO MORE ARGS?
	RET	Z		;ALL DONE
	CP	2
	JP	Z,2f		; 2 ARGS
	LD	DE,0		;CLEAR ARG #2
2:	LD	A,(QUEUE+QBOT)	;ADD TO BOTTOM
	CALL	STUFF_IT
	INC	A
	LD	(QUEUE+QBOT),A	;SAVE POINTER
	RET

	COND	0		;This code is not used at the present
QUEFRC:	AND	7Fh		;CLEAR FORCE BIT
	JP	Z,FEASY		;NO ARGS, EASY
	LD	A,C
	LD	B,0		;# ARGS
	POP	DE		;A(ROUTINE)
	LD	A,(QUEUE+QTOP)	;ADD TO THE TOP
	DEC	A
	DEC	A		;NEED TWO SLOTS
	CALL	STUFF_IT	;STUFF_IT WILL WRAP THE # IF NEEDED
	LD	(QUEUE+QTOP),A	;SAVE IT
	LD	A,C		;# OF ARG
	POP	BC
	POP	DE		;ARG 1 AND 2
	CP	2		;2 ARGS?
	JP	Z,1f		;YES...
	LD	DE,0		;NOPE, CLEAR ARG 2
1:	LD	A,(QUEUE+QTOP)	;WHERE TO PUT IT?
	INC	A
	CALL	STUFF_IT
	RET

FEASY:	LD	C,A
	LD	B,0
	POP	DE		;A(ROUTINE)
	LD	A,(QUEUE+QTOP)	;SLOT #
	DEC	A
	CALL	STUFF_IT
	LD	(QUEUE+QTOP),A	;Save pointer
	POP	DE
	POP	DE
	RET
	ENDC

QUEFULL:
	LD	HL,QUEFUL	;KEEP COUNT
	INC	(HL)
	JP	NZ,2f
	DEC	(HL)		;BUT DON'T WRAP
2:	RET
BADARG:
	LD	HL,8		;ADD 4 ARGS
	ADD	HL,SP
	LD	SP,HL
	RET

STUFF_IT:
	LD	HL,(QUEUE)	;GET HEADER
	INC	H		;GONNA ADD ONE MORE
	AND	L		;QUEUE.MAX MUST BE (2^N)-1 EX FF, OR 7F, 3F, ...)
	LD	(QUEUE),HL	;SAVE HEADER, DONE WITH IT
	LD	L,A
	LD	H,0		;MAKE DISPLACEMENT
	ADD	HL,HL		;SLOT # *2
	ADD	HL,HL		;SLOT # *4
	PUSH	DE
	LD	DE,QSLOTS	;BASE OF QUEUE ENTRIES
	ADD	HL,DE
	POP	DE		;HL IS NOW THE ADDRESS OF MY SLOT
	LD	(HL),C
	INC	HL
	LD	(HL),B		;SAVE #ARG OR ARG#1
	INC	HL
	LD	(HL),E
	INC	HL
	LD	(HL),D		;SAVE A(RTN) OR ARG#2
	RET

		;OS_TASK()	POP ITEM OFF QUEUE AND EXECUTE
		;		WILL HALT CPU IF NOTHING WAITING
		;		AND NEVER RETURN!
OS_TASK:
	LD	(IXSAVE),IX	;SAVE C REGS
	LD	(IYSAVE),IY
	LD	HL,0
	ADD	HL,SP
	LD	(SPSAVE),HL	; This should Never return

UNTIL_CRASH:
	DI	;INTS OFF!!!!!

	LD	A,(QUEUE+QUSED)	;HOW MANY ARE IN USE?
	OR	A		;Anything to Run?
	JP	NZ,CCALL	;Yes!! Call the C Function!

	EI	;INTS ON!!!!!!
	HALT			;Wait here for an interrupt
	JP	UNTIL_CRASH	;See what Havoc it caused...

restore:
	LD	HL,(SPSAVE)	;Restore Stack - It has args left on it
	LD	SP,HL
	LD	IX,(IXSAVE)
	LD	IY,(IYSAVE)
	JP	UNTIL_CRASH	;Do next thing

CCALL:	CALL	GET_TOP		;GET TOP ITEM, RET IN BC/DE
	LD	(TRTN),DE	;A(ROUTINE)
	LD	A,C		;# ARGS
	CP	0		;NONE?
	JP	Z,TNOMO		;Theres NO MOre
	PUSH	AF
	CALL	GET_TOP
	POP	AF
	CP	1
	JP	Z,1f		;ONLY 1 ARG
	PUSH	DE		;PUSH ARG #2
1:	PUSH	BC		;PUSH ARG #1

TNOMO:	EI	;INTS ON!!!!!!
	LD	HL,(TRTN)	;GET THE ROUTINE WE NEED TO JUMP TO
	LD	A,0C0h
	LD	(_COLD),A	;Flag that we are running a process
	CALL	indir		;DO IT, GOOD LUCK
	XOR	A
	LD	(_COLD),A	;All Done!

	ld	bc,0		;Port number
	ld	hl,2		;Insure our ports have at least 2 buffers
	push	hl
givlop:	ld	hl,340		;Number of bytes/buffer
	push	hl
	call	_new_buffer	;Allocate it!
	ld	a,l
	or	h
	jp	z,no_buf	;No more buffers this big
	ex	(sp),hl		;make rval arg
	push	bc
	call	_RX_GIVE
	pop	bc		;Port number
	pop	de		;trash
	ld	a,l
	or	h		;True if we want more
	jp	nz,givlop
	inc	bc
	ld	hl,-NUMCH	;Do it for all ports
	add	hl,bc		;If result is =>0 we are done
	jp	nc,givlop
	pop	hl
	jp	restore

no_buf:	pop	hl
	pop	hl
	ld	a,040H
	ld	(_COLD),a	;Note that we ran out of memory

	JP	restore

GET_TOP:
	LD	A,(QUEUE+QTOP)	;GET CURRENT TOP
	LD	L,A
	LD	H,0
	ADD	HL,HL		;TOP*2
	ADD	HL,HL		;TOP*4
	LD	DE,QSLOTS
	ADD	HL,DE		;ADDRESS OF TOP SLOT
	LD	C,(HL)
	INC	HL
	LD	B,(HL)
	INC	HL
	LD	E,(HL)
	INC	HL
	LD	D,(HL)
	LD	HL,(QUEUE)	;H=#USED L=MAX
	DEC	H
	LD	(QUEUE),HL
	JP	NZ,2f
	LD	HL,0		;CLEAR TOP&BOT
	LD	(QUEUE+2),HL
	RET
2:	LD	A,(QUEUE+QTOP)
	INC	A
	AND	L
	LD	(QUEUE+QTOP),A
	RET
